package org.mozilla.javascript;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Arrays;

import org.mozilla.javascript.Callable;
import org.mozilla.javascript.Context;
import org.mozilla.javascript.Function;
import org.mozilla.javascript.Scriptable;
import org.mozilla.javascript.ScriptableObject;

import com.nominanuda.hyperapi.async.AsyncInvoker;
import com.nominanuda.hyperapi.async.SuccessCallback;

public class AsyncHyperApiWrapper extends ScriptableObject {
	private static final long serialVersionUID = 1619466980386531638L;
	private final Object hyperApi;

	public AsyncHyperApiWrapper(Object hyperApi) {
		this.hyperApi = hyperApi;
	}
	@Override
	public String getClassName() {
		return "Object";
	}
	@Override
	public Object get(String name, Scriptable start) {
		for(Method m : hyperApi.getClass().getMethods()) {
			if (m.getName().equals(name)) {
				return new MethodWrapper(m);
			}
		}
		return super.get(name, start);
	}
	private class MethodWrapper implements Callable {
		public MethodWrapper(Method method) {
			this.method = method;
		}
		private final Method method;
		public Object call(final Context cx, final Scriptable scope, Scriptable thisObj,
				Object[] args) {
			Class<?>[] argTypes = method.getParameterTypes();
			if(args.length == argTypes.length) {
				MemberBox mb = new MemberBox(method);
				return mb.invoke(hyperApi, args);//TODO coerce and wrap result see nativejavaobject
			} else if(args.length > argTypes.length && args[argTypes.length] instanceof Function) {
				final Function jss = (Function)args[argTypes.length];
				SuccessCallback<?> ss = new SuccessCallback<Object>() {
					public void apply(Object data, String textStatus, Object jqXHR) {
						try {
							jss.call(cx, scope, null, new Object[] {data, textStatus, jqXHR});
						} catch(Exception e) {
							e.printStackTrace();
						}
					}
				};
				AsyncInvoker i = AsyncInvokerHolder.get();
				Object proxy = i.async(hyperApi, ss, null);
				try {
					return proxy.getClass().getMethod(method.getName(), method.getParameterTypes()).invoke(proxy, Arrays.copyOf(args, argTypes.length));
				} catch (IllegalArgumentException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (SecurityException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InvocationTargetException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (NoSuchMethodException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}//TODO coerce and wrap result

//				MemberBox mb = null;
//				try {
//					mb = new MemberBox(proxy.getClass().getMethod(method.getName(), method.getParameterTypes()));
//				} catch (SecurityException e) {
//					// TODO Auto-generated catch block
//					e.printStackTrace();
//				} catch (NoSuchMethodException e) {
//					// TODO Auto-generated catch block
//					e.printStackTrace();
//				}
//				return mb.invoke(proxy, args);//TODO coerce and wrap result
			} else {
				//TODO throw
			}
			return null;
		}
		
	}
}
